package birdiesoft.pokeassistant;

import birdiesoft.pokeassistant.enums.GameEnum;
import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class AddGameScreen extends Activity implements TextWatcher {
	private Spinner gameSelector = null;
	private EditText idText = null;
	private EditText nameText = null;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.addgame);

		gameSelector = (Spinner) findViewById(R.id.gameSelector);
		idText = (EditText) findViewById(R.id.idEdit);
		nameText = (EditText) findViewById(R.id.nameEdit);
		idText.addTextChangedListener(this);
		nameText.addTextChangedListener(this);
	}

	private int getId() {
		Editable idStr = idText.getText();
		if (idStr.length() == 0)
			return -1;
		else
			return Integer.parseInt(idStr.toString());
	}

	private String getName() {
		return nameText.getText().toString();
	}

	public void addGameClick(View view) {
		int gameId = (int) gameSelector.getSelectedItemId();
		GameEnum game = null;
		switch (gameId) {
		case 0:
			game = GameEnum.Black;
			break;
		case 1:
			game = GameEnum.White;
			break;
		}
		int id = getId();
		String name = getName();

		DataStore.addGame(game, id, name);
		finish();
	}

	@Override
	public void afterTextChanged(Editable arg0) {
		int id = getId();
		String name = getName();
		boolean canProceed = (name.length() != 0 && id >= 0 && id < 65536);
		Button addGameBtn = (Button) findViewById(R.id.AddBtn);
		addGameBtn.setEnabled(canProceed);
	}

	@Override
	public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
		// Do nothing.
	}

	@Override
	public void onTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
		// Do nothing.
	}
}
