package birdiesoft.pokeassistant;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import birdiesoft.pokeassistant.enums.GameEnum;

public class DataStore {
	private static DatabaseHelper dbHelper = null;
	private static SQLiteDatabase db = null;
	
	public static void init(Context context) {
		DatabaseHelper.initContext(context);
		dbHelper = new DatabaseHelper();
	}
	
	private static void getDb() {
		db = dbHelper.getDatabase();
	}
	
	public static void close() {
		dbHelper.close();
	}
	
	public static void addGame(GameEnum game, int id, String name) {
		getDb();
		ContentValues values = new ContentValues();
		values.put("game", game.toShortString());
		values.put("trainerid", id);
		values.put("trainername", name);
		db.insert("Game", null, values);
		close();
	}

	public static boolean hasData() {
		getDb();
		SQLiteStatement dataCountStmt = db.compileStatement("SELECT COUNT(*) FROM Game");
		long rows = dataCountStmt.simpleQueryForLong();
		close();
		return (rows != 0);
	}

	public static Game[] getGameList() {
		getDb();
		Cursor c = db.query("Game", null, null, null, null, null, "_id");
		int count = c.getCount();
		Game[] games = new Game[count];
		
		int idIdx = c.getColumnIndex("_id");
		int gameIdx = c.getColumnIndex("game");
		int tIdIdx = c.getColumnIndex("trainerid");
		int tNameIdx = c.getColumnIndex("trainername");
		
		for(int i = 0; i < count; i++) {
			c.moveToNext();
			games[i] = new Game(c.getInt(idIdx), c.getString(gameIdx), c.getInt(tIdIdx), c.getString(tNameIdx));
		}
		return games;
	}
}
