package birdiesoft.pokeassistant;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.os.Environment;

//Parts by Danny Remington
//http://stackoverflow.com/questions/513084/4810185#4810185
//Parts by Jon Evans
//http://pa.rezendi.com/2010/04/sqlite-on-android.html
public class DatabaseHelper {
	private static final int DATABASE_VERSION = 1;

	private static String DB_NAME = "pokeassistant.db";

	private static Context myContext = null;

	private SQLiteDatabase db;

	private File dbDir = null;
	private File dbFile = null;

	public static void initContext(Context context) {
		if (myContext == null)
			myContext = context;
	}

	public void open() {
		/*if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {
			dbDir = Environment.getExternalStorageDirectory();
			dbFile = new File(dbDir, DB_NAME);
		} else {*/
			dbFile = myContext.getDatabasePath(DB_NAME);
			dbDir = dbFile.getParentFile();
		//}
		if (dbFile.exists()) {
			db = SQLiteDatabase.openOrCreateDatabase(dbFile, null);
			if (DATABASE_VERSION > db.getVersion()) {
				upgrade();
				db = SQLiteDatabase.openOrCreateDatabase(dbFile, null);
			}
		} else {
			dbDir.mkdirs();
			db = SQLiteDatabase.openOrCreateDatabase(dbFile, null);
			create();
			db = SQLiteDatabase.openOrCreateDatabase(dbFile, null);
		}
	}

	public void close() {
		db.close();
		db = null;
	}

	public void create() {
		try {
			copyDatabase();
		} catch (IOException e) {
			throw new Error("Error copying database");
		}
	}

	public void upgrade() {
		try {
			File dbOld = new File(dbDir, "old_" + DB_NAME);
			FileHelper.copyFile(dbFile, dbOld);
			copyDatabase();
			// TODO: Transfer data
			// SQLiteDatabase old_db = SQLiteDatabase.openOrCreateDatabase(dbOld, null);
			// SQLiteDatabase new_db = SQLiteDatabase.openOrCreateDatabase(dbFile, null);
		} catch (IOException e) {
			throw new Error("Error copying database");
		}
	}

	private void copyDatabase() throws IOException {
		close();
		InputStream myInput = myContext.getAssets().open(DB_NAME);
		OutputStream myOutput = new FileOutputStream(dbFile);
		FileHelper.copyFile(myInput, myOutput);
		myInput.close();
		myOutput.flush();
		myOutput.close();
	}

	public SQLiteDatabase getDatabase() {
		if (db == null)
			open();
		return db;
	}
}
