package birdiesoft.pokeassistant;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.channels.FileChannel;

// Code by Danny Remington
// http://stackoverflow.com/questions/513084/4810185#4810185
public class FileHelper {
	public static void copyFile(InputStream fromFile, OutputStream toFile) throws IOException {
		byte[] buffer = new byte[1024];
		int length;

		try {
			while ((length = fromFile.read(buffer)) > 0) {
				toFile.write(buffer, 0, length);
			}
		}
		// Close the streams
		finally {
			try {
				if (toFile != null) {
					try {
						toFile.flush();
					} finally {
						toFile.close();
					}
				}
			} finally {
				if (fromFile != null) {
					fromFile.close();
				}
			}
		}
	}

	public static void copyFile(String fromFile, String toFile) throws IOException {
		copyFile(new FileInputStream(fromFile), new FileOutputStream(toFile));
	}

	public static void copyFile(File fromFile, File toFile) throws IOException {
		copyFile(new FileInputStream(fromFile), new FileOutputStream(toFile));
	}

	public static void copyFile(FileInputStream fromFile, FileOutputStream toFile) throws IOException {
		FileChannel fromChannel = fromFile.getChannel();
		FileChannel toChannel = toFile.getChannel();

		try {
			fromChannel.transferTo(0, fromChannel.size(), toChannel);
		} finally {
			try {
				if (fromChannel != null) {
					fromChannel.close();
				}
			} finally {
				if (toChannel != null) {
					toChannel.close();
				}
			}
		}
	}
}
