package birdiesoft.pokeassistant;

import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class GameListScreen extends ListActivity {
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d("GameListScreen", "Starting GameListScreen");
		setContentView(R.layout.gamelist);
		fillData();
	}
	
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		Game g = (Game)getListView().getItemAtPosition(position);
		Intent intent = new Intent();
		intent.putExtra("id", g.getId());
		Log.d("GameListScreen", "Item was clicked, id "+Integer.toString(g.getId()));
		setResult(RESULT_OK, intent);
		finish();
	}

	private void fillData() {
		Game[] games = DataStore.getGameList();
		ArrayAdapter<Game> adapter = new GameAdapter(this, R.layout.gamerow, games);
		setListAdapter(adapter);
	}
	
	private class GameAdapter extends ArrayAdapter<Game> {
	  private Game[] items;

	  public GameAdapter(Context context, int textViewResourceId, Game[] items) {
	          super(context, textViewResourceId, items);
	          this.items = items;
	  }

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;
			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.gamerow, null);
			}
			Game g = items[position];
			if (g != null) {
				TextView tt = (TextView) v.findViewById(R.id.gameLabel);
				TextView bt = (TextView) v.findViewById(R.id.infoLabel);
				if (tt != null) {
					tt.setText(g.getGame());
				}
				if (bt != null) {
					bt.setText(g.getInfo());
				}
			}
			return v;

		}
	}
}