package birdiesoft.pokeassistant;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

public class MainMenu extends Activity {
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		DataStore.init(getApplicationContext());
		setContentView(R.layout.main);
	}

	@Override
	protected void onResume() {
		super.onResume();
		boolean hasData = DataStore.hasData();
		Button openBtn = (Button) findViewById(R.id.OpenBtn);
		Button removeBtn = (Button) findViewById(R.id.RemoveBtn);

		openBtn.setEnabled(hasData);
		removeBtn.setEnabled(hasData);
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		Log.d("MainMenu", "Got activity result");
		if (resultCode == Activity.RESULT_OK) {
			Log.d("PokeAssistant", "Got result data: " + Integer.toString(data.getIntExtra("id", -1)));
		}
	}

	public void addGameClick(View view) {
		Intent intent = new Intent(this, AddGameScreen.class);
		startActivity(intent);
	}

	public void openGameClick(View view) {
		Intent intent = new Intent(this, GameListScreen.class);
		startActivityForResult(intent, -1);
	}

	public void removeGameClick(View view) {

	}

	public void exitClick(View view) {
		this.finish();
	}
}